uses sds, crt, alloc, files;

var module  : pointer;
    cevent  : array [0..31] of array [0..4] of byte;
    a,b,c,d : word;
    sh:sdmint_headtype;
    dlpp, dentry, dpatt, dspd, dbpm, drow:word;
    card:word;
    services : pointer;
    ch:char;
    k:word;

begin
  writeln('----------------------------------------------------------------------------');
  writeln(' Sound Deluxe System 5, a Maple Leaf production, 1996-1997');
  writeln(' Module to SDM converter (test)');
  writeln(' Supported formats: MOD,S3M,STM,MTM,FAR,ULT,669,SDM');
  writeln('----------------------------------------------------------------------------');

  if paramcount=0 then begin
    writeln(#13#10'Need a file name as parameter, you shithead !');
    halt;
  end;

  writeln('Free memory = ',mavail,' bytes');

  writeln('Loading module ...');
  UseUMB:=true; UseEMS:=true; { try to use EMS, if not found then try to use UMB }
  UseGUS:=false; { do not use GUS DRAM here }
  module:=sds_load(paramstr(1),true);

  if loaderror<>0 then begin
    writeln('Error loading module (errorcode=',loaderror,')');
    halt
  end;

  writeln('Converting to SDM ...');
  if not sds_save_sdm(module, onlydir(paramstr(1))+onlyname(paramstr(1))+'.SDM') then
    writeln('Saving error, code = ',saveerror);

  writeln('Unloading module ...');
  sds_unload(module);

  if loaderror<>0 then writeln('Deallocation error.');
  writeln('All done. Free memory = ',mavail,' bytes.');
end.