{$M 40000,0,0}
uses sds, crt, alloc, esb, dos, sds_det;

{ Some *IMPORTANT* mentions for future programs:

    The syncronization should be done using ESB (SDS's external
     syncronization block), whose address can be found at 0:[4FCh]
    The SURROUND mode should be initialized before play using
     either the ESB or the routine SDS_SetSurround()
}


var module  : pointer;
    cevent  : array [0..31] of array [0..4] of byte;
    a,b,c,d : word;
    sh:sdmint_headtype;
    dlpp, dentry, dpatt, dspd, dbpm, drow:word;
    card:word;

function choosecard:word;
var c:char; crd:word;
begin
  writeln('Choose soundcard :');
  writeln(' 1.Sound Blaster 1.0 or 2.0');
  writeln(' 2.Sound Blaster Pro (DSP 3.x)');
  writeln(' 3.Sound Blaster 16 ASP or AWE 32 (DSP 4.0)');
  writeln(' 4.Gravis UltraSound');
  writeln(' 5.Pro Audio Spectrum Plus/16');
  writeln(' 6.Crystal/Analog CODEC (WSS/AudioTrix Pro/GUS MAX CODEC)');
  writeln(' 7.UltraSilence!(tm) (no sound)');
  repeat
    repeat c:=readkey until c in ['1'..'7'];
    crd:=byte(c)-byte('0');
    c:='Y';
    case crd of
      1: if not DetectSB(Base, Irq, Dma) then c:='N';
      2: if not DetectSBPro(Base, Irq, Dma) then c:='N';
      3: if not DetectSB16(Base, Irq, Dma) then c:='N';
      4: if not DetectGUS(Base, Irq, Dma) then c:='N';
      5: if not DetectPAS(Base, Irq, Dma) then c:='N';
      6: if not DetectWSS(Base, Irq, Dma) then c:='N';
    end;
    if c<>'Y' then begin
      write(#13'Card not found, try again');
      sound(1000); delay(20); nosound
    end;
  until c='Y';
  write(#13); clreol;
  choosecard:=crd;
end;

begin
  writeln('----------------------------------------------------------------------------');
  writeln(' Sound Deluxe System 5, a Maple Leaf production, 1996-1997');
  writeln(' Background player, with DOS shell, POLL mode (test)');
  writeln('----------------------------------------------------------------------------');

  if paramcount=0 then begin
    writeln(#13#10'Need a file name as parameter, you shithead !');
    halt;
  end;

  writeln('Free memory = ',mavail,' bytes');

  card:=choosecard;
  writeln('Init card and DMA buffers ...');
  sds_init(card,$220{BasePort},7{IRQ},1{DMA#});

  writeln('Loading module ...');
  useems:=true;
  UseUMB:=true;
  module:=sds_load(paramstr(1),true);

  if loaderror<>0 then begin
    writeln('Error loading module (errorcode=',loaderror,')');
    halt
  end;

  writeln;
  writeln('Name        : ',modulename);
  writeln('Channels    : ',channels);
  writeln('Patterns    : ',patterns);
  writeln('Entries     : ',entries);
  writeln('Free memory : ',mavail,' bytes');

  writeln('Turning on surround sounds ...');
  sds_setsurround(true);

  writeln('Turning on poll-mixing ...');
  sds_setpollmix(true);

  writeln('Setting 25% gain ...');
  sds_setamplification(125);

  writeln('Starting module ...');
  sds_startplay(module, 0{InitSpeed(0=auto)}, 44100{MixSpeed}, 0{1=Pal,0=NTSC});

  writeln('Mixing. Type EXIT to stop.'#13#10);

  swapvectors;
  exec(getenv('COMSPEC'),'');
  swapvectors;

  writeln('Stopping ...');
  sds_stopplay;

  writeln('Shuting down SDS ...');
  sds_done;

  writeln('Unloading module ...');
  sds_unload(module);

  if loaderror<>0 then writeln('Deallocation error.');
  writeln('All done. Free memory = ',mavail,' bytes.');
end.